#ifndef DIALOG_H
#define DIALOG_H

#include <QtGui/QDialog>
#include "cwd.h"
#include "xlogger.h"
#include <string.h>
#include <QFile>
#include <QLineEdit>
 #include <QLCDNumber>
#include <QColor>
#include <QPalette>
#include <QDir>
#include <QMessageBox>



namespace Ui
{
    class Dialog;
}

class Dialog : public QDialog
{
    Q_OBJECT

public:
    Dialog(QWidget *parent = 0);
    ~Dialog();



private:
    Ui::Dialog *ui;

    std::string s;
    char mymsg[80];
    int msgtype;
    int serial;
    int lcd_cnt;
    int mode_cnt;
    char logmsg[1024];
    QString tempqso;
    QString oldqso;
    QString tmp;
    QString rd;
    QString cw_out;
    QDir h;
    QMessageBox msgBox;
    QString hp;


    cwd mycwd;
    xlogger xl;

    int cw_init(); // Returns if it worked or not
    void cw_close();
    void send_cw(QString);
    void save_cfg();
    void load_cfg();
    void pop_list();
    void btn_update();
    void push_list();
    void stuffit();
    void dflt_cfg();
    void tab_order();
    void cw_output(QString);
    void clr_log();
    void get_max_tab();
    void tab_init();
    void logit();
    void cq_labels();
    void snp_labels();
    void default_labels();
    const char* qtostr(QString);
    void dupe_chk();
    void set_hotkeys();
    void save_qso_nr();
    void load_qso_nr();
    QString cfg_dir_chk();
    QString  cut_nums(QString);



    QString macro_expander(QString);
    QString get_msg(int); //needs F-key index # and returns string to send
    QList<QString> c1_d;
    QList<QString> c2_d;
    QList<QString> c3_d;
    bool c1;
    bool c2;
    bool c3;
    bool do_cuts;
    QLineEdit* tabs[8];
    QLCDNumber* qlcd[8];
    QLineEdit* le[8];


private slots:

    void on_logcall_LE_lostFocus();
    void on_speed4_LE_textEdited(QString );
    void on_speed3_LE_textEdited(QString );
    void on_speed2_LE_textEdited(QString );
    void on_speed1_LE_textEdited(QString );
    void on_logcall_LE_textEdited(QString );
    void on_speed4_PB_clicked();
    void on_speed3_PB_clicked();
    void on_speed2_PB_clicked();
    void on_speed1_PB_clicked();
    void on_speed_LE_textChanged(QString );

    void on_pushButton_2_clicked();
    //void on_logcall_LE_textChanged(QString );
    void on_nr_LE_textChanged(QString );
    void on_logger_PB_clicked();
    void on_F_PB_clicked();
    void on_E_PB_clicked();
    void on_D_PB_clicked();
    void on_C_PB_clicked();
    void on_A_PB_clicked();
    void on_reset_PB_clicked();
    void on_tab_set_PB_clicked();
    void on_x2_LE_textChanged(QString );
    void on_x1_LE_textChanged(QString );
    void on_sec_LE_textChanged(QString );
    void on_urcall_LE_textChanged(QString );
    void on_f12_PB_clicked();
    void on_f11_PB_clicked();
    void on_f10_PB_clicked();
    void on_f9_PB_clicked();
    void on_f8_PB_clicked();
    void on_f7_PB_clicked();
    void on_f6_PB_clicked();
    void on_f5_PB_clicked();
    void on_f4_PB_clicked();
    void on_f3_PB_clicked();
    void on_f2_PB_clicked();
    void on_f1_PB_clicked();
    void on_bank_CB_currentIndexChanged(int index);
    void on_f12_LE_textChanged(QString );
    void on_f11_LE_textChanged(QString );
    void on_f10_LE_textChanged(QString );
    void on_f9_LE_textChanged(QString );
    void on_f8_LE_textChanged(QString );
    void on_f7_LE_textChanged(QString );
    void on_f6_LE_textChanged(QString );
    void on_f5_LE_textChanged(QString );
    void on_f4_LE_textChanged(QString );
    void on_f3_LE_textChanged(QString );
    void on_f2_LE_textChanged(QString );
    void on_f1_LE_textChanged(QString );
    void on_callsign_LE_textChanged(QString );
    void on_pushButton_4_clicked();
    void on_qso_LE_textChanged(QString );
    void on_pushButton_3_clicked();



};

#endif // DIALOG_H
